//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "SendMail"
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
#define REG_SAVE        "\\Software\\Utilmind Solutions\\SendMailDemo";

void __fastcall TMainForm::FixButtonState()
{
  AbortBtn->Enabled = SendMail1->Busy;
  SendBtn->Enabled = !(AbortBtn->Enabled);
}  

void __fastcall TMainForm::PrepareSendMail()
{
  SendMail1->SMTPHost = SMTPHostEdit->Text;
  SendMail1->SMTPPort = StrToIntDef(SMTPPortEdit->Text, 25);

  SendMail1->FromAddress = FromAddressEdit->Text;
  SendMail1->FromName = FromNameEdit->Text;
  SendMail1->FromOrganization = FromCompanyEdit->Text;
  SendMail1->ToAddr = ToEdit->Text;
  SendMail1->ToCC   = CCEdit->Text;
  SendMail1->ToBCC  = BCCEdit->Text;

  SendMail1->MsgSubject = SubjectEdit->Text;
  SendMail1->MsgBody    = Memo1->Text;
  SendMail1->MsgContentCharset = CharsetEdit->Text;
  if (PlainBox->Checked)
    SendMail1->MsgContentType = ctPlainText;
  else
    SendMail1->MsgContentType = ctHTML;
    
  SendMail1->MsgPriority = ((TSMTPPriority)PriorityBox->ItemIndex);

  if (AttachTypeBox->Checked)
    SendMail1->AttachType = atEmbedded;
  else
    SendMail1->AttachType = atNormal;
}

void __fastcall TMainForm::LoadSettings()
{
  TRegistry  *Reg;
  AnsiString Key;  

  Reg = new TRegistry;  
  try {
    Reg->RootKey = HKEY_CURRENT_USER;
    Key = REG_SAVE;
    if (Reg->OpenKey(Key, False)) {
      SMTPHostEdit->Text = Reg->ReadString("SMTPHost");
      SMTPPortEdit->Text = Reg->ReadString("SMTPPort1");
      if (SMTPPortEdit->Text != "") {
        SMTPPortEdit->Text = "25";
      }

      FromAddressEdit->Text = Reg->ReadString("FromAddress");
      FromNameEdit->Text = Reg->ReadString("FromName");
      FromCompanyEdit->Text = Reg->ReadString("FromOrganization");
      ToEdit->Text = Reg->ReadString("To");
      CCEdit->Text = Reg->ReadString("ToCC");
      BCCEdit->Text = Reg->ReadString("ToBCC");

      CharsetEdit->Text = Reg->ReadString("Charset");
      PlainBox->Checked = Reg->ReadBool("PlainText");
      HTMLBox->Checked = !(PlainBox->Checked);
      PriorityBox->ItemIndex = Reg->ReadInteger("Priority");

      SubjectEdit->Text = Reg->ReadString("Subject");
      Memo1->Text = Reg->ReadString("MsgBody");

      AttachTypeBox->Checked = Reg->ReadBool("AttachType");
    }
  } catch (Exception &E) {
  }
  delete Reg;
}   

void __fastcall TMainForm::StoreSettings()
{
  TRegistry  *Reg;
  AnsiString Key;  

  Reg = new TRegistry;  
  try {
    Reg->RootKey = HKEY_CURRENT_USER;
    Key = REG_SAVE;
    if (Reg->OpenKey(Key, True)) {
      Reg->WriteString("SMTPHost", SMTPHostEdit->Text);
      Reg->WriteString("SMTPPort1", SMTPPortEdit->Text);

      Reg->WriteString("FromAddress", FromAddressEdit->Text);
      Reg->WriteString("FromName", FromNameEdit->Text);
      Reg->WriteString("FromOrganization", FromCompanyEdit->Text);
      Reg->WriteString("To", ToEdit->Text);
      Reg->WriteString("ToCC", CCEdit->Text);
      Reg->WriteString("ToBCC", BCCEdit->Text);

      Reg->WriteString("Charset", CharsetEdit->Text);
      Reg->WriteBool("PlainText", PlainBox->Checked);
      Reg->WriteInteger("Priority", PriorityBox->ItemIndex);

      Reg->WriteString("Subject", SubjectEdit->Text);
      Reg->WriteString("MsgBody", Memo1->Text);

      Reg->WriteBool("AttachType", AttachTypeBox->Checked);
    }
  } catch (Exception &E) {
  }
  delete Reg;
}

//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
  PriorityBox->ItemIndex = 2;
  LoadSettings();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
  StoreSettings();        
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::SendBtnClick(TObject *Sender)
{
  PrepareSendMail();
  SendMail1->Send();
  FixButtonState();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::AbortBtnClick(TObject *Sender)
{
  SendMail1->Abort();
  FixButtonState();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::AttachBtnClick(TObject *Sender)
{
  int I;
  TListItem *AttachItem;

  if (OpenDialog1->Execute()) {
    OpenDialog1->InitialDir = ExtractFilePath(OpenDialog1->FileName);

    if (OpenDialog1->Files->Count != 0) {
      AttachPanel->Visible = True;
      for (I = 0; I < OpenDialog1->Files->Count; I++) {
        AttachItem = AttachView->Items->Add();
        AttachItem->Caption = ExtractFileName(OpenDialog1->Files->Strings[I]);
        SendMail1->Attach->Add(OpenDialog1->Files->Strings[I]); // attach
      }  

     AttachView->Update();
     while (AttachPanel->Height < 60) /* && AttachView->IsScrollBarsVisible() */ {
       AttachPanel->Height = AttachPanel->Height + 24;
     }
    }
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::AttachViewChange(TObject *Sender,
      TListItem *Item, TItemChange Change)
{
  Open1->Enabled = AttachView->Selected != NULL;
  Print1->Enabled = Open1->Enabled;
  Remove1->Enabled = Open1->Enabled;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Open1Click(TObject *Sender)
{
  if (AttachView->Selected != NULL) {
    ShellExecute(GetDesktopWindow(),
      (Sender == Print1) ? "print" : "open",
      SendMail1->Attach->Strings[AttachView->Selected->Index].c_str(),
      "", "", SW_SHOWNORMAL);
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Remove1Click(TObject *Sender)
{
  int I;

  if (AttachView->Selected != NULL) {
    for (I = AttachView->Items->Count - 1; I > 0; I--) {
      if (AttachView->Items->Item[I]->Selected) {
        SendMail1->Attach->Delete(I);
        AttachView->Items->Delete(AttachView->Selected->Index);
      }
    }    
    AttachPanel->Visible = AttachView->Items->Count != 0;
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::SaveBtnClick(TObject *Sender)
{
  if (SaveDialog->Execute()) {
    PrepareSendMail();
    SendMail1->SaveToFile(SaveDialog->FileName, True);
  }          
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::SendMail1Response(TObject *Sender, int Code,
      AnsiString Response)
{
  StatusList->Items->Add(Response);
  StatusList->ItemIndex = StatusList->Items->Count - 1;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::SendMail1HostUnreachable(TObject *Sender)
{
  Application->MessageBox("Specified SMTP server is unreachable.\r\n\n"
                          "Please check your Internet connection\r\n"
                          "or specify another SMTP host or/and port.",
                          "Host unreachable", MB_OK || MB_ICONSTOP);
  SMTPHostEdit->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::SendMail1SMTPError(TObject *Sender, int Code,
      AnsiString Response)
{
  StatusList->Items->Add("ERROR: " + Response);
  StatusList->ItemIndex = StatusList->Items->Count - 1;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::SendMail1Progress(TObject *Sender,
      int MessageSize, int BytesSent, BYTE PercentsDone)
{
  ProgressBar1->Position = PercentsDone;                
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::SendMail1ConnLost(TObject *Sender)
{
  ShowMessage("Connection Lost!");                
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::SendMail1Success(TObject *Sender)
{
  FixButtonState();
  ShowMessage("Message sent!");
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::SendMail1AnyError(TObject *Sender)
{
  FixButtonState();                
}
//---------------------------------------------------------------------------

